//	WaveOutfoCẌꗗуT|[gtH[}bg\
//	Visual C++ 2008/2013

#include <windows.h>
#include <shlobj.h>
#include <commctrl.h>
#include <stdio.h>
#include <tchar.h>
#include <mmsystem.h>
#include "resource.h"

#pragma comment(lib,"winmm.lib")

struct WAVE_FORM_TYPE{
	int flags;
	int samples;
	int channels;
	int bits;
};

static WAVE_FORM_TYPE wave_form_type_tbl[]={
	{ WAVE_FORMAT_1M08 , 11025, 1,  8 }, // 0x00001 
	{ WAVE_FORMAT_1S08 , 11025, 2,  8 }, // 0x00002 
	{ WAVE_FORMAT_1M16 , 11025, 1, 16 }, // 0x00004 
	{ WAVE_FORMAT_1S16 , 11025, 2, 16 }, // 0x00008 
	{ WAVE_FORMAT_2M08 , 22050, 1,  8 }, // 0x00010 
	{ WAVE_FORMAT_2S08 , 22050, 2,  8 }, // 0x00020 
	{ WAVE_FORMAT_2M16 , 22050, 1, 16 }, // 0x00040 
	{ WAVE_FORMAT_2S16 , 22050, 2, 16 }, // 0x00080 
	{ WAVE_FORMAT_4M08 , 44100, 1,  8 }, // 0x00100 
	{ WAVE_FORMAT_4S08 , 44100, 2,  8 }, // 0x00200 
	{ WAVE_FORMAT_4M16 , 44100, 1, 16 }, // 0x00400 
	{ WAVE_FORMAT_4S16 , 44100, 2, 16 }, // 0x00800 
	{ WAVE_FORMAT_44M08, 44100, 1,  8 }, // 0x00100 
	{ WAVE_FORMAT_44S08, 44100, 2,  8 }, // 0x00200 
	{ WAVE_FORMAT_44M16, 44100, 1, 16 }, // 0x00400 
	{ WAVE_FORMAT_44S16, 44100, 2, 16 }, // 0x00800 
	{ WAVE_FORMAT_48M08, 48000, 1,  8 }, // 0x01000 
	{ WAVE_FORMAT_48S08, 48000, 2,  8 }, // 0x02000 
	{ WAVE_FORMAT_48M16, 48000, 1, 16 }, // 0x04000 
	{ WAVE_FORMAT_48S16, 48000, 2, 16 }, // 0x08000 
	{ WAVE_FORMAT_96M08, 96000, 1,  8 }, // 0x10000 
	{ WAVE_FORMAT_96S08, 96000, 2,  8 }, // 0x20000 
	{ WAVE_FORMAT_96M16, 96000, 1, 16 }, // 0x40000 
	{ WAVE_FORMAT_96S16, 96000, 2, 16 }, // 0x80000 
{ 0, 0, 0, 0 } };

struct WAVE_SUPPORT_TBL{
	unsigned flags;
	TCHAR* str;
};

WAVE_SUPPORT_TBL wave_support_tbl[]={
{ WAVECAPS_LRVOLUME, _TEXT("WAVECAPS_LRVOLUME") },//EƗʃRg[
{ WAVECAPS_PITCH, _TEXT("WAVECAPS_PITCH") },//sb`ERg[
{ WAVECAPS_PLAYBACKRATE, _TEXT("WAVECAPS_PLAYBACKRATE") },//v[obNE[gERg[
{ WAVECAPS_SYNC, _TEXT("WAVECAPS_SYNC") },//̃hCo͓^ŁAĐ̓ubN
{ WAVECAPS_VOLUME, _TEXT("WAVECAPS_VOLUME") },//ʃRg[
{ WAVECAPS_SAMPLEACCURATE, _TEXT("WAVECAPS_SAMPLEACCURATE") },//Đʒu\@\
{ 0, 0 }};

//	T|[gĂWavetH[}bg𕶎񉻂
void SetWaveFormStr(TCHAR* buf, int sz, unsigned flags);

//	WaveOutfoCXT|[gĂ@\𕶎񉻂
void SetWaveSupportStr(TCHAR* buf, int sz, unsigned support);

//	_CAO{bNXvV[W[
LRESULT CALLBACK DlgProc1(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

int WINAPI _tWinMain(HINSTANCE hCurInst, HINSTANCE hPrevInst, TCHAR* lpsCmdLine, int nCmdShow){
	DialogBox(hCurInst, TEXT("DLG1"), 0, (DLGPROC)DlgProc1);
	return (int)0;
}

//	_CAO{bNXvV[W[

LRESULT CALLBACK DlgProc1(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){
	int num;
	static int max = 0;
	TCHAR buf[2048];
	WAVEOUTCAPS dev;
	switch (msg) {
	case WM_INITDIALOG:{
		int n;
		max=waveOutGetNumDevs();
		for (n = 0; n < max; n++){
			waveOutGetDevCaps(n,&dev,sizeof(dev));
			SendMessage(GetDlgItem(hDlg, IDC_COMBOBOX), CB_INSERTSTRING, n, (LPARAM)dev.szPname);	//R{{bNXɃACe̐ݒ
		}
		SendMessage(GetDlgItem(hDlg, IDC_COMBOBOX), CB_SETCURSEL, 0, (LPARAM)0);	//	ɑIACeI
		num = 0;
		waveOutGetDevCaps(num, &dev, sizeof(dev));
		buf[0] = _T('\0');
		_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("%s\r\nVersion %d.%d\r\n"), dev.szPname, dev.vDriverVersion / 256, dev.vDriverVersion & 0xff);
		SetWaveFormStr(buf, sizeof(buf) / sizeof(TCHAR), dev.dwFormats);
		SetWaveSupportStr(buf, sizeof(buf) / sizeof(TCHAR), dev.dwFormats);
		SetWindowText(GetDlgItem(hDlg, IDC_EDIT), buf);
		return TRUE;
	}
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_COMBOBOX:
			if (HIWORD(wParam) == CBN_SELCHANGE){	//	R{{bNX̃ACeIꂽƂɌĂяo
				num = (int)SendMessage(GetDlgItem(hDlg, IDC_COMBOBOX), CB_GETCURSEL, 0, 0);	//	J[\ʒũACe擾
				waveOutGetDevCaps(num, &dev, sizeof(dev));
				buf[0] = _T('\0');
				_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("%s\r\nVersion %d.%d\r\n"), dev.szPname,dev.vDriverVersion / 256, dev.vDriverVersion & 0xff);
				SetWaveFormStr(buf, sizeof(buf) / sizeof(TCHAR), dev.dwFormats);
				SetWaveSupportStr(buf, sizeof(buf) / sizeof(TCHAR), dev.dwFormats);
				SetWindowText(GetDlgItem(hDlg, IDC_EDIT), buf);
			}
			break;
		case IDCANCEL:
			EndDialog(hDlg, FALSE);
			return FALSE;
		default:
			return FALSE;
		}
	default:
		return FALSE;
	}
	return TRUE;
}

//	T|[gĂWavetH[}bg𕶎񉻂

void SetWaveFormStr(TCHAR* buf, int sz, unsigned flags){
	TCHAR temp[32];
	WAVE_FORM_TYPE* tbl = wave_form_type_tbl;

	int n = 0;
	while (tbl[n].flags){
		if (tbl[n].flags & flags){
			_stprintf_s(temp, sizeof(temp) / sizeof(TCHAR), TEXT("%dHz %d`l %drbg\r\n"), tbl[n].samples, tbl[n].channels, tbl[n].bits);
			_tcscat_s(buf, sz, temp);
		}
		++n;
	}
}

//	WaveOutfoCXT|[gĂ@\𕶎񉻂

void SetWaveSupportStr(TCHAR* buf, int sz, unsigned support){
	WAVE_SUPPORT_TBL* tbl = wave_support_tbl;
	TCHAR temp[64];
	int n = 0;
	while (tbl[n].flags){
		_stprintf_s(temp, sizeof(temp) / sizeof(TCHAR), _TEXT("%s %s\r\n"), tbl[n].str, (tbl[n].flags & support) ? _TEXT("T|[g") : _TEXT("T|[g"));
		_tcscat_s(buf, sz, temp);
		++n;
	}
}
